#pragma once
#include <luna/Result.h>

class OwnedStringView
{
  public:
    OwnedStringView(char* c_str);
    OwnedStringView();
    OwnedStringView(OwnedStringView&&);
    OwnedStringView(const OwnedStringView&) = delete;
    ~OwnedStringView();

    Result<OwnedStringView> clone() const;

    const char* chars() const
    {
        return m_string;
    }

    usize length() const
    {
        return m_length;
    }

    const char& operator[](usize index) const
    {
        expect(index < m_length, "OwnedStringView: index out of range");
        return m_string[index];
    }

  private:
    char* m_string{nullptr};
    usize m_length{0};
};